#include "cs.h"

extern CsObject *CsInstallObjectName(GENERIC_LIST **objects, char *name);
extern TERM *CsInstallObjectFeatureFunctor(CsObject *object, char *functor);
extern CsResource *CsInstallResourceName(CsResource **effectors, char *name);
extern TERM *CsInstallResourceFeatureFunctor(CsResource *effector, char *functor);
extern void CsNormaliseObjects(GENERIC_LIST *objects, int cycle);
extern void CsNormaliseResources(CsResource *effectors, int cycle);

extern CsObject *CsGetObject(GENERIC_LIST *object_list, char *object_name);
extern void CsResetObjectFeatures(CsObject *object);
extern CsResource *CsGetResource(CsResource *effector_list, char *effector_name);
extern void CsResetResourceFeatures(CsResource *effector);
extern TERM *install_argument_functor(TERM *functor, char *name);
extern void install_list_argument(TERM *functor, int n, ...);

/******************************************************************************/
/* The remainder of this file is task specific */

extern double CoffeeSituationTriggersObject();

GENERIC_LIST *CsInitialiseCoffeePreparationObjects()
{
    GENERIC_LIST *objects = NULL;
    CsObject *object;

    object = CsInstallObjectName(&objects, "sugar packet");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "salt packet");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "coffee packet");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "sugar bowl");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "cereal bowl");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "toast plate");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "juice glass");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "coffee mug");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "coffee jar");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "coffee jar lid");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "milk carton");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "teaspoon");
    object->triggering_situation = *CoffeeSituationTriggersObject;
    object = CsInstallObjectName(&objects, "stirrer");
    object->triggering_situation = *CoffeeSituationTriggersObject;

    return(objects);
}

void CsReinitialiseCoffeePreparationObjects(GENERIC_LIST *object_list)
{
    CsObject *object;
    TERM *functor;

    object = CsGetObject(object_list, "sugar packet");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 2, "sugar", "sugar");
    CsInstallObjectFeatureFunctor(object, "closed");
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "-2");
    install_argument_functor(functor, "2");

    object = CsGetObject(object_list, "salt packet");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 1, "salt");
    CsInstallObjectFeatureFunctor(object, "closed");
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "-2");
    install_argument_functor(functor, "2");

    object = CsGetObject(object_list, "coffee packet");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 1, "coffee");
    CsInstallObjectFeatureFunctor(object, "closed");
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "-2");
    install_argument_functor(functor, "2");

    object = CsGetObject(object_list, "sugar bowl");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 10, "sugar", "sugar", "sugar", "sugar", "sugar", "sugar", "sugar", "sugar", "sugar", "sugar");
    CsInstallObjectFeatureFunctor(object, "open");
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "-3");
    install_argument_functor(functor, "2");

    object = CsGetObject(object_list, "cereal bowl");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 20, "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal", "oatmeal");
    CsInstallObjectFeatureFunctor(object, "open");
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "0");
    install_argument_functor(functor, "1");

    object = CsGetObject(object_list, "toast plate");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 4, "toast", "toast", "toast", "toast");
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "3");
    install_argument_functor(functor, "2");

    object = CsGetObject(object_list, "juice glass");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 5, "juice", "juice", "juice", "juice", "juice");
    CsInstallObjectFeatureFunctor(object, "open");
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "2");
    install_argument_functor(functor, "2");

    object = CsGetObject(object_list, "coffee mug");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 15, "water", "water", "water", "water", "water", "water", "water", "water", "water", "water", "water", "water", "water", "water", "water");
    CsInstallObjectFeatureFunctor(object, "open");
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "-1");
    install_argument_functor(functor, "2");

    object = CsGetObject(object_list, "coffee jar");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 50, "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee", "coffee");
    CsInstallObjectFeatureFunctor(object, "open");
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "-2");
    install_argument_functor(functor, "3");

    object = CsGetObject(object_list, "coffee jar lid");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "-3");
    install_argument_functor(functor, "3");

    object = CsGetObject(object_list, "milk carton");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 50, "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk", "milk");
    CsInstallObjectFeatureFunctor(object, "closed");
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "3");
    install_argument_functor(functor, "3");

    object = CsGetObject(object_list, "teaspoon");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "contains");
    install_list_argument(functor, 0);
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "1");
    install_argument_functor(functor, "2");

    object = CsGetObject(object_list, "stirrer");
    CsResetObjectFeatures(object);
    functor = CsInstallObjectFeatureFunctor(object, "position");
    install_argument_functor(functor, "-2");
    install_argument_functor(functor, "2");

    if (MATHS == NORMALISED) {
        CsNormaliseObjects(object_list, 0);
    }
}

CsResource *CsInitialiseCoffeePreparationResources()
{
    CsResource *effectors = NULL;

    CsInstallResourceName(&effectors, "Left Hand");
    CsInstallResourceName(&effectors, "Right Hand");

    return(effectors);
}

void CsReinitialiseCoffeePreparationResources(CsResource *effector_list)
{
    CsResource *effector;
    TERM *functor;

    effector = CsGetResource(effector_list, "Left Hand");
    CsResetResourceFeatures(effector);
    functor = CsInstallResourceFeatureFunctor(effector, "holds");
    install_list_argument(functor, 0);

    effector = CsGetResource(effector_list, "Right Hand");
    CsResetResourceFeatures(effector);
    functor = CsInstallResourceFeatureFunctor(effector, "holds");
    install_list_argument(functor, 0);

    if (MATHS == NORMALISED) {
        CsNormaliseResources(effector_list, 0);
    }
}

/******************************************************************************/
