/******************************************************************************/

#include "cs.h"

/******************************************************************************/

extern int  CsRun(FILE *file, TaskType task);
extern void CsMessage(MessageType mt, int cycle, char *message);
extern void CsInitialise(TaskType task);
extern void CsSetDefaultParameters(TaskType task);
extern void CsPrintParameters(FILE *fp, TaskType task);
extern void ActRecord(ActionType act, int cycle, char *arg1, char *arg2);
extern void ActAnalyseList(FILE *fp, TaskType task);

static TaskType current_task = COFFEE_PREPARATION;

/******************************************************************************/

void AttachData(int cycle, BOOLEAN redraw) {} /* Called from outside */

static void RunCallback(FILE *fp, TaskType task)
{
    int cycles = 0;
    CsRun(fp, task);
    CsMessage(WARNING, cycles, "Run complete\n\n");
    ActAnalyseList(stdout, task);
}

/********* MAIN ***************************************************************/

int main(int argc, char **argv)
{
    CsSetDefaultParameters(current_task);
    CsPrintParameters(stdout, current_task);
    CsInitialise(current_task);
    RunCallback(stdout, current_task);
    return(0);
}

/******** END OF FILE *********************************************************/
