/******************************************************************************/

#include "cs.h"

#define BLOCKS  100

/******************************************************************************/

extern void ActAnalyseList(FILE *fp);
extern int  CsRun(FILE *file, TaskType task);
extern void CsInitialise(TaskType task);
extern void CsSetDefaultParameters(TaskType task);
extern void CsPrintParameters(FILE *fp, TaskType task);
extern char *random_seed();

static TaskType current_task = COFFEE_PREPARATION;

/******************************************************************************/

void AttachData(int cycle, BOOLEAN redraw) {}

/********* MAIN ***************************************************************/

void main(int argc, char **argv)
{
    extern void ActMultiReset();
    extern void ActMultiAnalyseList(TaskType task);
    extern void ActMultiPrint(char *prefix, double par);

    int i = 0, j;

    if (argc == 2) {
        CsInitialise(current_task);
        CsSetDefaultParameters(current_task);
        for (SCHEMA_PE = 1.00; SCHEMA_PE > 0.29; SCHEMA_PE = SCHEMA_PE - 0.01) {
            i++;
            CsPrintParameters(stdout, current_task);
            ActMultiReset();
            for (j = 0; j < BLOCKS; j++) {
                fprintf(stdout, "\nRun %d.%d\n", i, j);
                CsRun(stdout, current_task);
                ActMultiAnalyseList(current_task);
            }
            ActMultiPrint(argv[1], SCHEMA_PE);
        }
    }
    else {
        fprintf(stderr, "%s: usage: %s output-file\n", argv[0], argv[0]);
    }
}

/******** END OF FILE *********************************************************/
